import { __awaiter } from "tslib";
import { transformWithEsbuild } from 'vite';
export function angularVitestPlugin() {
    return {
        name: '@analogjs/vitest-angular-esm-plugin',
        apply: 'serve',
        enforce: 'post',
        config() {
            return {
                ssr: {
                    noExternal: [/fesm2022/],
                },
                test: {
                    pool: 'vmThreads',
                },
            };
        },
        transform(_code, id) {
            return __awaiter(this, void 0, void 0, function* () {
                if (/fesm2022/.test(id) && _code.includes('async (')) {
                    const { code, map } = yield transformWithEsbuild(_code, id, {
                        loader: 'js',
                        format: 'esm',
                        target: 'es2016',
                        sourcemap: true,
                        sourcefile: id,
                    });
                    return {
                        code,
                        map,
                    };
                }
                return undefined;
            });
        },
    };
}
//# sourceMappingURL=angular-vitest-plugin.js.map